Attribute VB_Name = "easyRun"
' ------------------------------------------------------------------------------
'
' easyRun(easyRun.bas)                                    Ulrich Mller 11.02.00
'                                                         Procida 400NT    VB6.0
' Modul zur Erstellung eigener VB6-Programme zum Betrieb von ft-Modellen
' auf Basis von umFishEx.BAS, umFish.DLL und easyMain.FRM
' die aufgefhrten Komponenten knnen ungendert eingebunden werden.
' Es stehen die normalen VB6-Sprachmittel und Funktionen aus
' umFishEx und easyMain zur Verfgung
'
' Beispiel Pnematic Robots : Greifer
'
' ------------------------------------------------------------------------------

Option Explicit

' ------------------- Anwendungs-Konstanten -----------------------------------
Private Const cvArmA = 1, cvArmB = 2, cvGreifer = 3, cmKompressor = 4
Private Const ctReset = 8


Private Sub ArmPosA()
' --- Arm nach Postion A ----
  ftiSetMotor cvArmB, ftiAus
  ftiSetMotor cvArmA, ftiEin
  If ftiGetInput(ctReset) Then Exit Sub       ' --- Abbruch durch Reset
  printStatus "Positon A"
  ftiWaitForTime 2000
End Sub


Private Sub ArmPosB()
' --- Arm nach Postion B ---------
  ftiSetMotor cvArmA, ftiAus
  ftiSetMotor cvArmB, ftiEin
  If ftiGetInput(ctReset) Then Exit Sub  ' --- Abbruch durch Reset
  printStatus "Position B"
  ftiWaitForTime 2000
End Sub


Private Sub GreiferZu()
' --- Greifer schlieen -----
  ftiSetMotor cvGreifer, ftiEin
  If ftiGetInput(ctReset) Then Exit Sub  ' --- Abbruch durch Reset
  printStatus "Greifer Zu"
  ftiWaitForTime 2000
End Sub

Private Sub GreiferAuf()
' --- Greifer ffnen -----
  ftiSetMotor cvGreifer, ftiAus
  If ftiGetInput(ctReset) Then Exit Sub  ' --- Abbruch durch Reset
  printStatus "Greifer Auf"
  ftiWaitForTime 2000
End Sub


Private Sub printStatus(T$)
' --- Ausgabe von Text in das Statusfeld ---------
  easyMain.lblStatus.Caption = T
End Sub

Private Function Werte(Nr&)
' --- Zugriff auf den numerischen Inhalt der Werte Felder ---
  Werte = Val(easyMain.txtWert(Nr))
End Function

Public Sub fishText()
' --- Beschriften der Textfelder in der Hautform ---
'     Bei Bedarf : eigene Werte eintragen ----------
With easyMain
  .lblTitel = "Verkehrsampel"
  .lblEText(1).Caption = "E1"
  .lblEText(2).Caption = "E2"
  .lblEText(3).Caption = "E3"
  .lblEText(4).Caption = "E4"
  .lblEText(5).Caption = "E5"
  .lblEText(6).Caption = "E6"
  .lblEText(7).Caption = "E7"
  .lblEText(8).Caption = "Reset"
  .lblMText(1).Caption = "Arm A"
  .lblMText(2).Caption = "Arm B"
  .lblMText(3).Caption = "Greifer"
  .lblMText(4).Caption = "Kompressor"
  .lblAText(0).Caption = "EX"
  .lblAText(1).Caption = "EY"
  .lblWert(1).Caption = "Wert A"
  .txtWert(1).Text = 0
  .lblWert(2).Caption = "Wert B"
  .txtWert(2).Text = 0
End With
End Sub

Public Sub fishMain()

' --- Hauptroutine, Name ist fest ----------------------------------
'     wird fr jede Anwendung neu erstellt
'     Aufruf ber START-Button
'     es knnen beliebige weitere sub und function erstellt werden.
' -------------- Hauptroutine --------------------------------------
  
  ftiSetMotor cmKompressor, ftiEin
  ftiWaitForTime 3000
  GreiferAuf
  ArmPosA
  printStatus "Anlage ready"
  
  Do
    GreiferZu
    ArmPosB
    GreiferAuf
    ArmPosA
    ArmPosB
    GreiferZu
    ArmPosA
    GreiferAuf
    ArmPosB
    ArmPosA
  Loop Until ftiFinish(ctReset)
  
End Sub

