Attribute VB_Name = "easyRun"
' ------------------------------------------------------------------------------
'
' easyRun(easyRun.bas)                                    Ulrich Mller 03.10.01
'                                                         Procida 400NT    VB6.0
' Computing Starter Pack : Temperaturregelung
' auf Basis von umFishEx.BAS, umFish.DLL und easyMain.FRM
' die aufgefhrten Komponenten knnen ungendert eingebunden werden.
' Es stehen die normalen VB6-Sprachmittel und Funktionen aus
' umFishEx und easyMain zur Verfgung
'
' ------------------------------------------------------------------------------

Option Explicit

' ------------------- Anwendungs-Konstanten -----------------------------------

  Const mKhlung = 1, mHeizung = 2, aFhler = 0, wHei = 1, wKalt = 2

' ------------------- Anwendungs-Variable -------------------------------------

' ------------------- Allgemeine Routinen -------------------------------------

Private Sub printStatus(ByVal T$)
' --- Ausgabe von Text in das Statusfeld ---------
  easyMain.lblStatus.Caption = T
End Sub

Private Function Werte(Nr&)
' --- Zugriff auf den numerischen Inhalt der Werte Felder ---
  Werte = Val(easyMain.txtWert(Nr))
End Function

Public Sub fishText()
' --- Beschriften der Textfelder in der Hautform ---
'     Bei Bedarf : eigene Werte eintragen ----------
With easyMain
  .lblTitel = "Temperaturregelung"
  .lblEText(1).Caption = "E1"
  .lblEText(2).Caption = "E2"
  .lblEText(3).Caption = "E3"
  .lblEText(4).Caption = "E4"
  .lblEText(5).Caption = "E5"
  .lblEText(6).Caption = "E6"
  .lblEText(7).Caption = "E7"
  .lblEText(8).Caption = "E8"
  .lblMText(1).Caption = "Khlung"
  .lblMText(2).Caption = "Heizung"
  .lblMText(3).Caption = "M3"
  .lblMText(4).Caption = "M4"
  .lblAText(0).Caption = "TempFhler"
  .lblAText(1).Caption = "EY"
  .lblWert(1).Caption = "Hei"
  .txtWert(1).Text = 520
  .lblWert(2).Caption = "Kalt"
  .txtWert(2).Text = 560
End With
End Sub

Public Sub fishMain()

' --- Hauptroutine, Name ist fest ----------------------------------
'     wird fr jede Anwendung neu erstellt
'     Aufruf ber START-Button
'     es knnen beliebige weitere private sub und function erstellt werden.
' -------------- Hauptroutine --------------------------------------

Dim Temperatur&

  Do
    Temperatur = ftiGetAnalog(aFhler)
    Select Case Temperatur
    Case Is < Werte(wHei)
      printStatus "--- khlt ---"
      ftiSetMotor mHeizung, ftiAus
      ftiSetMotor mKhlung, ftiEin
    Case Is > Werte(wKalt)
      printStatus "--- heizt ---"
      ftiSetMotor mHeizung, ftiEin
      ftiSetMotor mKhlung, ftiAus
    End Select
  Loop Until ftiFinish(0)
  
End Sub

