Attribute VB_Name = "umFishEx"
' ------------------------------------------------------------------------------
'
' umFishEx(umFishEx.bas)                                  Ulrich Mller 11.02.00
'                                                         Procida 400NT    VB6.0
' Funktionen zum Betrieb der fischertechnik Interfaces
' auf Basis von umFish.DLL v1.2 :
'
' Funktionen zum Betrieb der fischertechnik Interfaces
' auf Basis von umFish.DLL v1.2 :
'
' Laufzeitdaten       : ftiDCB     : record, kein Aufrufparameter
'                       ftiNotHalt : Abbruchwunsch
'                       nur ein Interface pro Programm ( & Slave)
' Unterbrechbarkeit   : Integration von  Application.ProcessMessages.
' Abbrechbarkeit      : Variable ftiNotHalt, die Escape-Taste und Timelimit
'                       (bei langlaufenden Funktionen)
' Refresh             : direkt oder indirekt durch ftiGetInputs
'                       alle 300ms erforderlich
' Kontrolle Interface : ftiOpenInterface / ftiCloseInterface
'                       (WinNT|parallel : ftiStartDriver / ftiStopDriver)
' Lesen Eingabe       : ftiGetInputs / ftiGetInput, ftiGetAnalog
' Schreiben Ausgabe   : ftiSetMotors / ftiSetMotor / ftiClearMotors,
'                       ftiSetLamp
' Warten auf Ereignis : ftiWaitForTime, ftiWaitForInput,
'                       ftiWaitForChange, ftiWaitForLow
' Abbruchwunsch       : ftiBeenden

' ------------------------------------------------------------------------------

Option Explicit

Public Declare Function OpenInterface Lib "umFish.dll" _
  (ft As ftDCB, ByVal ComName$) As Long
Public Declare Function CloseInterface Lib "umFish.dll" _
  (ft As ftDCB) As Long
Public Declare Function GetInput Lib "umFish.dll" _
  (ft As ftDCB, ByVal InputNr&) As Boolean
Public Declare Function GetInputs Lib "umFish.dll" _
  (ft As ftDCB) As Long
Public Declare Function ClearMotors Lib "umFish.dll" (ft As ftDCB) As Long
Public Declare Function SetMotors Lib "umFish.dll" _
  (ft As ftDCB, ByVal MotorStatus&) As Long
Public Declare Function SetMotor Lib "umFish.dll" _
  (ft As ftDCB, ByVal MotorNr&, ByVal Richtung&) As Long
Public Declare Function SetLamp Lib "umFish.dll" _
  (ft As ftDCB, ByVal LampNr&, ByVal OnOff&) As Long
Public Declare Function GetAnalog Lib "umFish.dll" _
  (ft As ftDCB, ByVal AnalogNr&) As Long

Public Declare Function StartDriver Lib "umFish.dll" () As Long
Public Declare Function StopDriver Lib "umFish.dll" () As Long

Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Const VK_ESCAPE = &H1B
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMsec&)
Public Declare Function GetTickCount Lib "kernel32" () As Long


Public Type ftDCB
  comI As Long
  PortID As Long
  LPTDelay As Long
  LPTAnalog As Long
  InputStatus As Long
  MotorStatus As Long
End Type

Public Const ftiFehler = &H1FFFF
Public Const ftiAus = 0
Public Const ftiEin = 1
Public Const ftiLinks = 1
Public Const ftiRechts = 2

Public ftiDCB As ftDCB, ftiNotHalt As Boolean

Private EMaske(1 To 16) As Long


Public Function ftiOpenInterface(PortName$) As Long

' --- Verbindung zum Interface herstellen ----------

' --- EMaske initialisieren ---

  EMaske(1) = &H1
  EMaske(2) = &H2
  EMaske(3) = &H4
  EMaske(4) = &H8
  EMaske(5) = &H10
  EMaske(6) = &H20
  EMaske(7) = &H40
  EMaske(8) = &H80
  EMaske(9) = &H100
  EMaske(10) = &H200
  EMaske(11) = &H400
  EMaske(12) = &H800
  EMaske(13) = &H1000
  EMaske(14) = &H2000
  EMaske(15) = &H4000
  EMaske(16) = &H8000
  
  ftiNotHalt = False
  ftiOpenInterface = OpenInterface(ftiDCB, PortName)
  
End Function

Public Function ftiCloseInterface() As Long

' --- Verbindung zum Interface beenden ----

  ftiCloseInterface = CloseInterface(ftiDCB)
  
End Function


Public Function ftiGetInputs() As Long
  
' --- Auslesen Status aller Digitaleingnge ----

  ftiGetInputs = GetInputs(ftiDCB)
  DoEvents
  
End Function

Public Function ftiGetInput(ByVal InputNr As Long) As Boolean
  
' --- Auslesen Status Digitaleingang InputNr ----------------

  ftiGetInput = GetInput(ftiDCB, InputNr)
  DoEvents
  
End Function

Public Function ftiGetAnalog(ByVal AnalogNr As Long) As Long
  
' --- Auslesen Wert Analogeingang AnalogNr -----------------

  ftiGetAnalog = GetAnalog(ftiDCB, AnalogNr)
  DoEvents
  
End Function

Public Function ftiSetMotors(MotorStatus&) As Long

' --- Setzen aller Ausgnge ----------------------

  ftiSetMotors = SetMotors(ftiDCB, MotorStatus)
  
End Function

Public Function ftiSetMotor(MotorNr&, Direction&) As Long

' --- Setzen Ausgang MotorNr auf Direction --------------

  ftiSetMotor = SetMotor(ftiDCB, MotorNr, Direction)
  
End Function

Public Function ftiClearMotors() As Long

' --- Ausschalten aller Ausgnge -------

  ftiClearMotors = ClearMotors(ftiDCB)
  
End Function

Public Function ftiSetLamp(LampNr&, OnOff&) As Long

' ---- Setzen eines "halben" Ausganges LampNr auf OnOff ----

  ftiSetLamp = SetLamp(ftiDCB, LampNr, OnOff)
  
End Function

Public Function ftiWaitForInput(InputNr&, Optional OnOff As Boolean = True) As Long
  
' --- Warten bis Eingang = OnOff wird -------------------------------------
'     Abbruch bei ftiNotHalt, Escape

  Do
    DoEvents
    If ftiNotHalt Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then
      ftiWaitForInput = ftiFehler
      Exit Function
    End If
  Loop Until GetInput(ftiDCB, InputNr) = OnOff
  ftiWaitForInput = ftiDCB.InputStatus
  
End Function

Public Function ftiWaitForChange(InputNr&, NrOfChanges&, Optional TermInputNr& = 0) As Long

' --- Warten auf eine oder mehrere (NrOfChanges) nderungen des Status
'     des Einganges InputNr bzw. TermInputNr = true ------------------
'     Abbruch bei ftiNotHalt, escape, AbbruchZeit, Fehler, Endtaster

Const AbbruchDelta = 800
Dim i&, res&, M2&, M3&, res1 As Boolean, res2 As Boolean, AbbruchZeit&

  ftiWaitForChange = ftiFehler
  res = GetInput(ftiDCB, InputNr)
  res1 = (res = True)
  M2 = EMaske(InputNr)
  If TermInputNr = 0 Then
    M3 = 0
  Else
    M3 = EMaske(TermInputNr)
    res = GetInputs(ftiDCB)
    If (res And M3) > 0 Then
      ftiWaitForChange = res
      Exit Function
    End If
  End If
  
  For i = 1 To NrOfChanges
    AbbruchZeit = GetTickCount + AbbruchDelta
    Do
      DoEvents
      res = GetInputs(ftiDCB)
      If (res = ftiFehler) Or ftiNotHalt Or (GetAsyncKeyState(VK_ESCAPE) <> 0) _
                           Or ((res And M3) > 0) _
                           Or (GetTickCount > AbbruchZeit) Then Exit Function
      res2 = (res And M2) > 0
      Loop Until res1 <> res2
      res1 = res2
  Next i
  ftiWaitForChange = res
  
End Function

Public Function ftiWaitForLow(InputNr&) As Long

' --- Warten auf einen true/false Durchgang von InputNr ---
'     Abbruch bei ftiNotHalt, Escape, Fehler

Dim res&, M2&, res1 As Boolean, res2 As Boolean

  ftiWaitForLow = ftiFehler
  res = GetInput(ftiDCB, InputNr)
  res1 = (res = True)
  M2 = EMaske(InputNr)
  
  If Not res1 Then
    Do
      DoEvents
      res = GetInputs(ftiDCB)
      If (res = ftiFehler) Or ftiNotHalt _
          Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then Exit Function
      res2 = (res And M2) > 0
    Loop Until res2
  End If
  
  Do
    DoEvents
    res = GetInputs(ftiDCB)
    If (res = ftiFehler) Or ftiNotHalt _
       Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then Exit Function
    res2 = (res And M2) > 0
  Loop Until Not res2
  ftiWaitForLow = res
  
End Function

Public Sub ftiWaitForTime(ByVal mSek&)

' --- eine vorgegebene Zeit warten -----
'     Abbruch bei ftiNotHalt, Escape ---

Dim sZeit&, nSek&, res&

  nSek = mSek
  sZeit = GetTickCount()
  Do
    DoEvents
    res = GetInputs(ftiDCB)
  Loop Until ftiNotHalt Or ((GetTickCount() - sZeit) > nSek) _
       Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Or res = ftiFehler
       
End Sub

Public Function ftiFinish(InputNr&) As Boolean

' --- Feststellen eines Endewunsches : ftiNotHalt, Escape, InputNr ----

  ftiFinish = False
  If ftiNotHalt Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then ftiFinish = True
  If InputNr > 0 Then If GetInput(ftiDCB, InputNr) Then ftiFinish = True
  DoEvents
  
End Function
